function [w, fval] = l2svmball(spam_label, spam_inst, b)

% You need to replace this with the directory of MOSEK toolbox on your computer
addpath 'C:\Program Files\Mosek\6\toolbox\r2009b';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear prob;

ninst = size(spam_inst, 1);
nfea = size(spam_inst, 2);

prob.c = [sparse(nfea, 1); ones(ninst, 1)];


prob.qcsubk = ones(1, nfea); 
prob.qcsubi = 1:nfea; 
prob.qcsubj = 1:nfea; 
prob.qcval  = -2*ones(1, nfea);

prob.a = [sparse(1, nfea+ninst); diag(spam_label)*spam_inst sparse(1:ninst, 1:ninst, 1); sparse(ninst, nfea) sparse(1:ninst, 1:ninst, 1)];

prob.blc = [-b^2; ones(ninst, 1); sparse(ninst, 1)];
prob.buc = [];
prob.blx = [];
prob.bux = [];

[~, res] = mosekopt('minimize echo(0)', prob);

w = res.sol.itr.xx(1:nfea);
fval = res.sol.itr.pobjval;
end