function [w, fval] = l2svm(spam_label, spam_inst, eta)

% You need to replace this with the directory of MOSEK toolbox on your computer
addpath 'C:\Program Files\Mosek\6\toolbox\r2009b';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear prob;

ninst = size(spam_inst, 1);
nfea = size(spam_inst, 2);

prob.qosubi = 1:nfea; 
prob.qosubj = 1:nfea; 
prob.qoval  = 1/eta*ones(nfea, 1); 

prob.c = [sparse(nfea, 1); ones(ninst, 1)];
prob.a = [diag(spam_label)*spam_inst sparse(1:ninst, 1:ninst, 1); sparse(ninst, nfea) sparse(1:ninst, 1:ninst, 1)];
prob.blc = [ones(ninst, 1); sparse(ninst, 1)];

prob.buc = [];
prob.blx = [];
prob.bux = [];

[~, res] = mosekopt('minimize echo(0)', prob);

w = res.sol.itr.xx(1:nfea);
fval = res.sol.itr.pobjval;
end